<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditaArtigoIdiomaJSONResponse StructType
 * @subpackage Structs
 */
class EditaArtigoIdiomaJSONResponse extends AbstractStructBase
{
    /**
     * The EditaArtigoIdiomaJSONResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EditaArtigoIdiomaJSONResult;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for EditaArtigoIdiomaJSONResponse
     * @uses EditaArtigoIdiomaJSONResponse::setEditaArtigoIdiomaJSONResult()
     * @uses EditaArtigoIdiomaJSONResponse::setMensagem()
     * @uses EditaArtigoIdiomaJSONResponse::setSucesso()
     * @param string $editaArtigoIdiomaJSONResult
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct($editaArtigoIdiomaJSONResult = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setEditaArtigoIdiomaJSONResult($editaArtigoIdiomaJSONResult)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get EditaArtigoIdiomaJSONResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEditaArtigoIdiomaJSONResult()
    {
        return isset($this->EditaArtigoIdiomaJSONResult) ? $this->EditaArtigoIdiomaJSONResult : null;
    }
    /**
     * Set EditaArtigoIdiomaJSONResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $editaArtigoIdiomaJSONResult
     * @return \StructType\EditaArtigoIdiomaJSONResponse
     */
    public function setEditaArtigoIdiomaJSONResult($editaArtigoIdiomaJSONResult = null)
    {
        // validation for constraint: string
        if (!is_null($editaArtigoIdiomaJSONResult) && !is_string($editaArtigoIdiomaJSONResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($editaArtigoIdiomaJSONResult)), __LINE__);
        }
        if (is_null($editaArtigoIdiomaJSONResult) || (is_array($editaArtigoIdiomaJSONResult) && empty($editaArtigoIdiomaJSONResult))) {
            unset($this->EditaArtigoIdiomaJSONResult);
        } else {
            $this->EditaArtigoIdiomaJSONResult = $editaArtigoIdiomaJSONResult;
        }
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\EditaArtigoIdiomaJSONResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\EditaArtigoIdiomaJSONResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EditaArtigoIdiomaJSONResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
